localConfig = {
	["Mal der Wildnis"] = 1;
	["Arkane Intelligenz"] = 0;
	["Machtwort: Seelenstrke"] = 1;
	["Gttlicher Willen"] = 0;
	["Schattenschutz"] = 0;
	["Dornen"] = 0;
	["Segen der Macht"] = 0;
	["Segen der Weisheit"] = 0;
	["Segen der Rettung"] = 0;
	["Segen der Knige"] = 0;
	["Segen des Lichts"] = 0;
	["Duration"] = 0;
	["Debug"] = false;
	["Cancel"] = 0;
	["ActiveConfig"] = 1;
}

localConfig2 = {
	["Mal der Wildnis"] = 1;
	["Arkane Intelligenz"] = 0;
	["Machtwort: Seelenstrke"] = 1;
	["Gttlicher Willen"] = 0;
	["Schattenschutz"] = 0;
	["Dornen"] = 0;
	["Segen der Macht"] = 0;
	["Segen der Weisheit"] = 0;
	["Segen der Rettung"] = 0;
	["Segen der Knige"] = 0;
	["Segen des Lichts"] = 0;
	["Duration"] = 0;
	["Debug"] = false;
	["Cancel"] = 0;
	["ActiveConfig"] = 1;
}


local RequestString = "";

local activeConfig = 1;

BINDING_HEADER_RBRHeader = "Raid Buff Request";
BINDING_NAME_RBRRequest = "Request Buffs";

function RaidBuffRequest_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("ADDON_LOADED");
	SlashCmdList["RBR"] = RBR_showOptions;
	SLASH_RBR1 = "/rbr";
	DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cOnLoad);
end; 

function RaidBuffRequest_CloseFrame()
	RaidBuffRequestFrame:Hide();
	localConfig["ActiveConfig"]=activeConfig;
	RBRSave = localConfig;
	RBRSave2 = localConfig2;
end;

function RBR_showOptions(cmd)
	local parsed=false;
	if(cmd=="disable") then
		DisableAddOn("RaidBuffRequest");
		ReloadUI();
		parsed=true;
	end;
	if(cmd=="help") then
		DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cHelpCommands["Format"]);
		DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cHelpCommands["Help"]);
		DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cHelpCommands["Disable"]);
		DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cHelpCommands["Debug"]);
		parsed=true;
	end;
	if(cmd=="") then 
		RaidBuffRequestFrame:Show();
		parsed=true;
	end;
	if(cmd=="debug") then
		localConfig["Debug"] = not localConfig["Debug"];
		parsed=true;
	end;
	if(parsed==false) then
		DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cHelpCMD);
	end;
end;


function RaidBuffRequest_ChangeBuff()
	localConfig["Mal der Wildnis"] = RaidBuffRequest_CB1:GetChecked();
	localConfig["Arkane Intelligenz"] = RaidBuffRequest_CB2:GetChecked();
	localConfig["Machtwort: Seelenstrke"] = RaidBuffRequest_CB3:GetChecked();
	localConfig["Gttlicher Willen"] = RaidBuffRequest_CB4:GetChecked();
	localConfig["Schattenschutz"] = RaidBuffRequest_CB5:GetChecked();
	localConfig["Dornen"] = RaidBuffRequest_CB6:GetChecked();
	localConfig["Segen der Macht"] = RaidBuffRequest_CB7:GetChecked();
	localConfig["Segen der Weisheit"] = RaidBuffRequest_CB8:GetChecked();
	localConfig["Segen der Rettung"] = RaidBuffRequest_CB9:GetChecked();
	localConfig["Segen der Knige"] = RaidBuffRequest_CB10:GetChecked();
	localConfig["Segen des Lichts"] = RaidBuffRequest_CB11:GetChecked();
	localConfig["Cancel"] = RaidBuffRequest_CB12:GetChecked();
end;

function RaidBuffRequest_loadConfig()
	activeConfig=1;
	if(RBRSave~=nil) then 
		localConfig = RBRSave;
	end;
	if(RBRSave2~=nil) then
		localConfig2 = RBRSave2;
	else
		localConfig2 = localConfig;
	end;
	activeConfig = localConfig["ActiveConfig"];
	RaidBuffRequest_CB1:SetChecked(localConfig["Mal der Wildnis"]);
	RaidBuffRequest_CB2:SetChecked(localConfig["Arkane Intelligenz"]);
	RaidBuffRequest_CB3:SetChecked(localConfig["Machtwort: Seelenstrke"]);
	RaidBuffRequest_CB4:SetChecked(localConfig["Gttlicher Willen"]);
	RaidBuffRequest_CB5:SetChecked(localConfig["Schattenschutz"]);
	RaidBuffRequest_CB6:SetChecked(localConfig["Dornen"]);
	RaidBuffRequest_CB7:SetChecked(localConfig["Segen der Macht"]);
	RaidBuffRequest_CB8:SetChecked(localConfig["Segen der Weisheit"]);
	RaidBuffRequest_CB9:SetChecked(localConfig["Segen der Rettung"]);
	RaidBuffRequest_CB10:SetChecked(localConfig["Segen der Knige"]);
	RaidBuffRequest_CB11:SetChecked(localConfig["Segen des Lichts"]);
	RaidBuffRequest_CB12:SetChecked(localConfig["Cancel"]);
	RaidBuffRequest_Slider1:SetValue(localConfig["Duration"]);
	activeConfig = localConfig["ActiveConfig"];
	RaidBuffRequest_ActiveConfig:SetText(RaidBuffRequest_cCurrentSet.." "..activeConfig);
	if(UnitFactionGroup("player")~="Alliance") then
		RaidBuffRequest_CB7:Disable();
		RaidBuffRequest_CB8:Disable();
		RaidBuffRequest_CB9:Disable();
		RaidBuffRequest_CB10:Disable();
		RaidBuffRequest_CB11:Disable();
		RaidBuffRequest_BS7:SetTextColor(0.2,0.2,0.2,100);
		RaidBuffRequest_BS8:SetTextColor(0.2,0.2,0.2,100);
		RaidBuffRequest_BS9:SetTextColor(0.2,0.2,0.2,100);
		RaidBuffRequest_BS10:SetTextColor(0.2,0.2,0.2,100);
		RaidBuffRequest_BS11:SetTextColor(0.2,0.2,0.2,100);
	else
		RaidBuffRequest_CB7:Enable();
		RaidBuffRequest_CB8:Enable();
		RaidBuffRequest_CB9:Enable();
		RaidBuffRequest_CB10:Enable();
		RaidBuffRequest_CB11:Enable();
		RaidBuffRequest_BS7:SetTextColor(1,0.81,0,100);
		RaidBuffRequest_BS8:SetTextColor(1,0.81,0,100);
		RaidBuffRequest_BS9:SetTextColor(1,0.81,0,100);
		RaidBuffRequest_BS10:SetTextColor(1,0.81,0,100);
		RaidBuffRequest_BS11:SetTextColor(1,0.81,0,100);

	end;
end;

function RaidBuffRequest_OnEvent()
	if(event == "ADDON_LOADED") then
		RaidBuffRequest_loadConfig();
	end;
end;

function RaidBuffRequest_RequestBuffs()
	RequestString=RaidBuffRequest_cRequest.."[";
	local buffed={
		["Mal der Wildnis"] = false;
		["Dornen"] = false;
		["Machtwort: Seelenstrke"] = false;
		["Arkane Intelligenz"] = false;
		["Gttlicher Willen"] = false;
		["Schattenschutz"] = false;
		["Segen der Macht"] = false;
		["Segen der Weisheit"] = false;
		["Segen der Rettung"] = false;
		["Segen der Knige"] = false;
		["Segen des Lichts"] = false;
	};
	local buff_ID = 0;
	local buff_index, untilCancelled = GetPlayerBuff(0, "HELPFUL"); 
	local subgroup;
	
	while (buff_index >= 0) do
	    if(untilCancelled~=1) then
	    	
	    	if strfind(GetPlayerBuffTexture(buff_index),"Spell_Nature_Regeneration") then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("MDW: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Mal der Wildnis"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if strfind(GetPlayerBuffTexture(buff_index),"Spell_Nature_Thorns") then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("Dornen: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Dornen"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_WordFortitude") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_PrayerOfFortitude")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("STA: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Machtwort: Seelenstrke"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_MagicalSentry") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_ArcaneIntellect")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("STA: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Arkane Intelligenz"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_DivineSpirit") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_PrayerofSpirit")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("Wille: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Gttlicher Willen"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Shadow_AntiShadow") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_PrayerofShadowProtection")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("Shatten: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Schattenschutz"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_FistOfJustice") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_GreaterBlessingofKings")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("SdM: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Segen der Macht"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_GreaterBlessingofWisdom") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_SealOfWisdom")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("SdW: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Segen der Weisheit"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;

	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_SealOfSalvation") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_GreaterBlessingofSalvation")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("SdR: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Segen der Rettung"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;

	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Magic_MageArmor") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Magic_GreaterBlessingofKings")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("SdK: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Segen der Knige"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;

	    	if (strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_PrayerOfHealing02") or strfind(GetPlayerBuffTexture(buff_index),"Spell_Holy_GreaterBlessingofLight")) then
	    		if(GetPlayerBuffTimeLeft(buff_index)>=localConfig["Duration"]) then
					if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage("SdK: "..GetPlayerBuffTimeLeft(buff_index));end;
	    			buffed["Segen des Lichts"]=true;
	    		end;
	    		if(GetPlayerBuffTimeLeft(buff_index)<localConfig["Duration"]) and (localConfig["Cancel"]==1) then
	    			CancelPlayerBuff(buff_index);
	    		end;
	    	end;
	    	
	    end;
	    buff_ID = buff_ID + 1;
	    buff_index, untilCancelled = GetPlayerBuff(buff_ID, "HELPFUL");
	end;
	
	if(buffed["Mal der Wildnis"]==false) and (localConfig["Mal der Wildnis"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff1_Short;end;
	if(buffed["Arkane Intelligenz"]==false) and (localConfig["Arkane Intelligenz"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff2_Short;end;
	if(buffed["Machtwort: Seelenstrke"]==false) and (localConfig["Machtwort: Seelenstrke"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff3_Short;end;
	if(buffed["Gttlicher Willen"]==false) and (localConfig["Gttlicher Willen"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff4_Short;end;
	if(buffed["Schattenschutz"]==false) and (localConfig["Schattenschutz"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff5_Short;end;
	if(buffed["Dornen"]==false) and (localConfig["Dornen"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff6_Short;end;
	if(buffed["Segen der Macht"]==false) and (localConfig["Segen der Macht"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff7_Short;end;
	if(buffed["Segen der Weisheit"]==false) and (localConfig["Segen der Weisheit"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff8_Short;end;
	if(buffed["Segen der Rettung"]==false) and (localConfig["Segen der Rettung"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff9_Short;end;
	if(buffed["Segen der Knige"]==false) and (localConfig["Segen der Knige"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff10_Short;end;
	if(buffed["Segen des Lichts"]==false) and (localConfig["Segen des Lichts"]==1) then RequestString=RequestString.." "..RaidBuffRequest_cBuff11_Short;end;
	c=0;
	name="";
	if UnitInRaid("player") then
		while (name~=UnitName("player")) do
			c=c+1;
			name, rank, subgroup, level, class, fileName, zone, online = GetRaidRosterInfo(c);
			if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage(name);end;
		end;
		RequestString=RequestString.." "..RaidBuffRequest_cIn.." "..RaidBuffRequest_cGroup.." "..subgroup;
		RequestString=RequestString.." ]";
		if(localConfig["Debug"]==false) then
			if (RequestString~=RaidBuffRequest_cRequest.."[".." "..RaidBuffRequest_cIn.." "..RaidBuffRequest_cGroup.." "..subgroup.." ]") then 
				SendChatMessage(RequestString,"RAID");
			else
				DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cFullyBuffed);
			end;
		end;
		if(localConfig["Debug"]==true) then DEFAULT_CHAT_FRAME:AddMessage(RequestString);end;
	else
		DEFAULT_CHAT_FRAME:AddMessage(RaidBuffRequest_cRaidGrp);
	end;
	

	
end;

function RaidBuffRequest_DurationChange()
	local time="";
	localConfig["Duration"]=RaidBuffRequest_Slider1:GetValue();
	if (mod(localConfig["Duration"],60)>9) then
		time=(floor(localConfig["Duration"]/60))..":"..(mod(localConfig["Duration"],60));
	else
		time=(floor(localConfig["Duration"]/60))..":0"..(mod(localConfig["Duration"],60));
	end;
	RaidBuffRequest_SL1:SetText(time);
end;

function RaidBuffRequest_UpdateUI()
	RaidBuffRequest_CB1:SetChecked(localConfig["Mal der Wildnis"]);
	RaidBuffRequest_CB2:SetChecked(localConfig["Arkane Intelligenz"]);
	RaidBuffRequest_CB3:SetChecked(localConfig["Machtwort: Seelenstrke"]);
	RaidBuffRequest_CB4:SetChecked(localConfig["Gttlicher Willen"]);
	RaidBuffRequest_CB5:SetChecked(localConfig["Schattenschutz"]);
	RaidBuffRequest_CB6:SetChecked(localConfig["Dornen"]);
	RaidBuffRequest_CB7:SetChecked(localConfig["Segen der Macht"]);
	RaidBuffRequest_CB8:SetChecked(localConfig["Segen der Weisheit"]);
	RaidBuffRequest_CB9:SetChecked(localConfig["Segen der Rettung"]);
	RaidBuffRequest_CB10:SetChecked(localConfig["Segen der Knige"]);
	RaidBuffRequest_CB11:SetChecked(localConfig["Segen des Lichts"]);
	RaidBuffRequest_CB12:SetChecked(localConfig["Cancel"]);
	RaidBuffRequest_Slider1:SetValue(localConfig["Duration"]);
	RaidBuffRequest_ActiveConfig:SetText(RaidBuffRequest_cCurrentSet.." "..activeConfig);
end;

function RaidBuffRequest_BuffSet1Select()
	if (activeConfig==2) then
		activeConfig=1;
		localConfig["ActiveConfig"]=1;
		localConfig2["ActiveConfig"]=1;
		temp=localConfig;
		localConfig=localConfig2;
		localConfig2=temp;
		RaidBuffRequest_UpdateUI();
	end;
end;

function RaidBuffRequest_BuffSet2Select()
	if (activeConfig==1) then
		activeConfig=2;
		localConfig["ActiveConfig"]=2;
		localConfig2["ActiveConfig"]=2;
		temp=localConfig;
		localConfig=localConfig2;
		localConfig2=temp;
		RaidBuffRequest_UpdateUI();
	end;
end;